/**
 * 
  xd87.h   XD87 keyboard interface of "Hobo-nicola keyboard and adapter library".
  Copyright (c) 2020 Takeshi Higasa
  
  This file is part of "Hobo-nicola keyboard and adapter".

  "Hobo-nicola keyboard and adapter" is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  "Hobo-nicola keyboard and adapter" is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with "Hobo-nicola keyboard and adapter".  If not, see <http://www.gnu.org/licenses/>.
  
  Included in hoboNicola 1.5.0.		Jul. 25. 2021.
	
*/

#ifndef __XD87__H__
#define __XD87__H__
void init_xd87();
void matrix_scan();
uint8_t get_key(bool& pressed, bool us_layout);
void enter_dfu_bootloader();
void set_rgb_value(uint8_t val);

#define BGLED(a)    PORTD = a ? PORTD & ~_BV(0) : PORTD | _BV(0)
#define CAPSLED(a)  PORTE = a ? PORTE & ~_BV(2) : PORTE | _BV(2)

#endif
